


# java classpath for calling BEAST

java.classpath <- ".;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\bin;C:\\AAA\\Programming\\Goteborg\\workspace\\beast16\\lib\\*"

setwd("C:/AAA/Programming/Goteborg/simulation_di_tets_multigene")

               




library(ape)

source("AlloppSim_0randomseeds.r")

source("AlloppSim_1readconfig2.r")
source("AlloppSim_2makemultree.r")
source("AlloppSim_3makegtrees.r")
source("AlloppSim_4makeseqfiles.r")
source("AlloppSim_5beastxml_toplevel.r")
source("AlloppSim_6beastxml_bits.r")


source("C:/AAA/Programming/GoteborgReal/Gossypium/fileinfo.r")

lineparts <- lines.from.gtable()
ngenes <- length(lineparts)
stopifnot(ngenes == 47)




Gossypium.seqs.filebase <- "C:/AAA/Programming/GoteborgReal/Gossypium/AlignedSeqs/asq"


make.beastxml.for.cotton2dip.data <- function(sampledgtrees.fpathbase, sampledmultrees.fpath, sampledparams.fpath, 
                 DBUGTUNE.fpath, mulTreeVersion) {
  nofdiploids <- 2
  noftetraploids <- 1
  noftetratrees <- 1
  taxastruct <- cotton2dip.taxa.structure()

  make.beastxml.start("Cotton data, 2 diploids")
  
  nofgenes <- make.cotton2dip.taxa.and.alignments()
  commentln("Patterns")
  for (g in 1:nofgenes) {
    make.patterns(g)
    }

  make.beastxml.after.patterns(nofdiploids, noftetraploids, noftetratrees, nofgenes, 
                   taxastruct,
                   sampledgtrees.fpathbase, sampledmultrees.fpath, sampledparams.fpath,
                   DBUGTUNE.fpath, mulTreeVersion)
}



cotton2dip.taxa <- function() {
  taxa <- c("01Gossypium_ah_X", "01Gossypium_raimondii_X", "01Gossypium_hb_A", "01Gossypium_hb_D")   
  taxa
}


cotton2dip.taxa.structure <- function() {
  spp <- c("Gossypium_ah", "Gossypium_raimondii", "Gossypium_hb")
  struct <- NULL
  struct <- c(struct, list(list(sp=spp[1], indivs="01", sqs=c("_X")))) 
  struct <- c(struct, list(list(sp=spp[2], indivs="01", sqs=c("_X")))) 
  struct <- c(struct, list(list(sp=spp[3], indivs="01", sqs=c("_A", "_D")))) 
  struct
}


make.cotton2dip.taxa.and.alignments <- function() {
  commentln("Taxa. Each taxon is a sequence (labelled A,D or X) from")
  commentln("an individual (01) in a species (eg Gossypium_ah).")
  noffiles <- 2   # will be derived from files
  taxa <- cotton2dip.taxa()
  cat("\t<taxa id=\"taxa\">\n")
  for (i in 1:length(taxa)) {
    cat("\t\t<taxon id=\"", taxa[i], "\"/>\n", sep="")
    }
  cat("\t</taxa>\n")

  
  for (g in 1:noffiles) {
    commentln(paste("Alignment for gene", g, "."))
    textlines <- readLines(paste(Gossypium.seqs.filebase, g, ".fas", sep=""))
    n <- length(textlines)
  
    tokens <- strsplit(textlines, split=" +")
    for (i in 1:n) {
      stopifnot(length(tokens[[i]]) == 1  ||  length(tokens[[i]]) == 2)
      }
    
    
    # find starts and ends of sequences for each taxon tx
    seqstart <- rep(0, length(taxa))
    seqlast <- rep(0, length(taxa))
    for (tx in 1:length(taxa)) {
      for (i in 1:n) {
        if (tokens[[i]][1] == ">"  &&  grepl( tokens[[i]][2], taxa[tx])) {
          seqstart[tx] <- i+1
          for (j in (i+1):n) {
            if (tokens[[j]][1] == ">"  &&  seqlast[tx] == 0) {
              seqlast[tx] <- j-1
            }
          }
          if (seqlast[tx] == 0) { seqlast[tx] <- n }
        }
      }
    }
    
  cat("\t<alignment id=\"alignment", g, "\" dataType=\"nucleotide\">\n", sep="")  
  for (tx in 1:length(taxa)) {
    cat("\t\t<sequence>\n", sep="")
    cat("\t\t\t<taxon idref=\"", taxa[tx], "\" />\n", sep="")
    seqnce <- ""
    for (ss in seqstart[tx]:seqlast[tx]) {
      seqnce <- paste(seqnce, tokens[[ss]], sep="", collapse="")
      }
    cat(seqnce, "\n", sep="")
    cat("\t\t</sequence>\n", sep="")
    }
  cat("\t</alignment>\n")
  }
  noffiles
}


 
####################################################################
####################################################################


beast.chain.length <- "500000"
beast.screen.logevery <- "1000"
beast.params.logevery <- "1000"
beast.gtrees.logevery <- "1000"
beast.multree.logevery <- "1000"
beast.dbugtune.logevery <- "10000"
treeann.burnin <- "101"


dpath <- "C:/AAA/Programming/GoteborgReal/Gossypium/beast/"

sink(paste(dpath, "NET-beastin.xml", sep=""))
make.beastxml.for.cotton2dip.data(paste(dpath, "NET-gtree", sep=""),
                                  paste(dpath, "NET-multree.txt", sep=""), 
                                  paste(dpath, "NET-params.txt", sep=""),
                                  paste(dpath, "NET-DBUGTUNE.txt", sep=""), FALSE)
sink(NULL)
                 

sink(paste(dpath, "MUL-beastin.xml", sep=""))
make.beastxml.for.cotton2dip.data(paste(dpath, "MUL-gtree", sep=""),
                                  paste(dpath, "MUL-multree.txt", sep=""), 
                                  paste(dpath, "MUL-params.txt", sep=""),
                                  paste(dpath, "MUL-DBUGTUNE.txt", sep=""), TRUE)

sink(NULL)
                 
