
# simple way to view a few trees informally.
# need to edit this to say which trees


setwd("C:/AAA/Programming/Goteborg/simulation_di_tets_multigene")
# where this code is


library(ape)

source("AlloppSim_1readconfig2.r")
source("Analysis_readannotatedtree.r")
  
config.dir <- "C:/AAA/Programming/GoteborgSim/2012-01-04/net-mul-test-Bt"


analysis.info <- analysis.info.from.config.dir(config.dir)
all.files.prefix  <- analysis.info$all.files.prefix




phylo.simmul <- read.tree(text="(((a0:0.005,z0:0.005):0.01,z1:0.015):0.01,b0:0.025);")




round.treeheight <- function(hgt) {
hstr <- ""
if (hgt > .01) { hstr <- round(hgt, digits=3) } else { hstr <- signif(hgt, digits=2) }
hstr
}

plot.treewithscale <- function(phyl, textsize, treetype, g=-1) {
  plot.phylo(phyl, cex=textsize)
  bts <- branching.times(phyl)
  if (g >= 0) {
    title(paste(treetype, g, "height=", round.treeheight(max(bts))))
    } else {
    title(paste(treetype, "height=", round.treeheight(max(bts))))
    }
  }
  


plot.treetoscale <- function(phyl, textsize, treetype, hgt, g=-1) {
  bts <- branching.times(phyl)
  rootheight <- max(bts)
  x <- plot.phylo(phyl, cex=textsize, x.lim=hgt)
  #print(x)
  if (g >= 0) {
    title(paste(treetype, g, "height=", round.treeheight(rootheight)))
    } else {
    title(paste(treetype, "height=", round.treeheight(rootheight)))
    }
  }               


plot.empty <- function() {
plot(x=NULL,y=NULL, xlim=c(0,1), ylim=c(0,1), axes=FALSE, xlab="", ylab="")
title("(Spacer)")
}


plot.simgtrees.mccgtrees.multree <- function() {
ncolumns <- max(ngtrees,2)
par(mfrow=c(3,ncolumns))  
maxrootheight <- 0
for (g in 1:ngtrees) {
  bts <- branching.times(list.gtrees[[g]])
  rootheight <- max(bts)
  maxrootheight <- max(maxrootheight, rootheight)
  bts <- branching.times(list.mccgtrees[[g]])
  rootheight <- max(bts)
  maxrootheight <- max(maxrootheight, rootheight)
  } 
plotwidth <- maxrootheight*1.1        

for (g in 1:ncolumns) {
  if (g <= ngtrees) {
    plot.treetoscale(list.gtrees[[g]], 1.3, "Simulated gtree", plotwidth, g)
    } else {
    plot.empty()
    }
  }

for (g in 1:ncolumns) {
  if (g <= ngtrees) {
  plot.treetoscale(list.mccgtrees[[g]], 1.3, "Concensus gtree", plotwidth, g)
    } else {
    plot.empty()
    }
  }         

plot.treetoscale(phylo.simmul, 1.3, "Simulated MULtree", plotwidth)
plot.treetoscale(phylo.mccmultree, 1.3, "Concensus MULtree", plotwidth)
if (ncolumns > 2) {
  for (g in 3:ncolumns) {
    plot.empty()
    }
  }
}




cfgnum <- 1
repl <- 5



config <- read.config2(paste(config.dir, "/", "config.txt", sep=""))
nofGNT <- length(config$configG)
ngtrees <- config$configG[cfgnum]
nreps   <- config$configR[cfgnum]


              

list.gtrees <- NULL
for (g in 1:ngtrees) {
  newick.gtree <- scan(fpath.gtree(config, cfgnum, repl, g), what="")
  nc <-  nchar(newick.gtree)
  if (substr(newick.gtree,nc,nc) == ")") {
    newick.gtree <- paste(newick.gtree, ";", sep="")
    }
  phylo.gtree <- read.tree(text=newick.gtree)
 
  list.gtrees <- c(list.gtrees, list(phylo.gtree))
  }         

list.mccgtrees <- NULL
for (g in 1:ngtrees) {
  phylo.mccgtree <- read.nexus(file=fpath.mccgtree(config, cfgnum, repl, g)) 
  list.mccgtrees <- c(list.mccgtrees, list(phylo.mccgtree))
  }         

# read tree twice: first using ape to draw it...
phylo.mccmultree <- read.nexus(file=fpath.mccmultree(config, cfgnum, repl))
# ... second using my code for annotations, esp posterior
nodes <- read.annotated.tree(fpath.mccmultree(config, cfgnum, repl))


clade.of.node <- function(nodes, i, clade) {
if (nodes[i, "lft"] < 0) {
  clade <- nodes[i,"node"]
  } else {
  lftc <- clade.of.node(nodes, nodes[i, "lft"], clade)
  rgtc <- clade.of.node(nodes, nodes[i, "rgt"], clade)
  clade <- c(lftc, rgtc)
  }
clade
}



plot.simgtrees.mccgtrees.multree()

png(file=paste(config.dir, "/G", config$configG[cfgnum], 
                 "N", config$configN[cfgnum], "T", config$configT[cfgnum], 
                 "r", repl, ".png", sep=""), 
                 bg="white", width=3000, height=1000, pointsize=15)
plot.simgtrees.mccgtrees.multree()
dev.off()


for (i in 1:dim(nodes)[1]) {
  x <- clade.of.node(nodes, i, NULL)
  if (length(x) > 1) {
    cat("clade", x, "posterior", nodes[i,"posterior"], "\n")
  }
}



