


setwd("C:/AAA/Programming/Goteborg/simulation_di_tets_multigene")
# where this code is


library(ape)

source("AlloppSim_1readconfig2.r")


config.dir <- "C:/AAA/Programming/GoteborgSim/2011-12-29/net-mul-test-Bt"

analysis.info <- analysis.info.from.config.dir(config.dir)
all.files.prefix  <- analysis.info$all.files.prefix


# copy also in AlloppSim_main
mccmultree.is.simmultree <- function(config, i, r) {
  mccmul <- read.nexus(file=fpath.mccmultree(config, i, r))
  sametopol <- all.equal(analysis.info$simmul1, mccmul, use.edge.length = FALSE)
  sametopol <- sametopol  ||  all.equal(analysis.info$simmul2, mccmul, use.edge.length = FALSE)
  sametopol
  }





config <- read.config2(paste(config.dir, "/", "config.txt", sep=""))
nofGNT <- length(config$configG)


display.gtree <- function(config, i, r, g) {
  fn <- fpath.gtree(config, i, r, g)
  newick <- scan(fn, what="")
  nc <-  nchar(newick)
  if (substr(newick,nc,nc) == ")") {
    newick <- paste(newick, ";", sep="")
    }
  phy <- read.tree(text=newick)
  plot.phylo(phy)
  }


# this is flaky
display.barplot <- function() {
clrs <- rep(rgb(.5,.5,.5), nofGNT)
for (i in 1:nofGNT) {
  tone <- 0.3 + 0.4*config$configN[i]/config$configN[nofGNT]
  red <- 0.3*(config$configT[i]-config$configT[1])/(1.1*config$configT[nofGNT]-config$configT[1])
  if (tone < 0) { tone <- 0 }
  if (red < 0) { red <- 0 }
  if (red + tone > 1) {
    red <- red /( red + tone)
    tone <- tone / (red + tone)
    }
  clrs[i] <- rgb(tone+red, tone, tone)
  }

coords <- barplot(counts, horiz=TRUE, col=clrs)
for (i in 1:nofGNT) {
  text(0, coords[i], snames[i], adj=c(0,0.5), cex=1.5)
  }
}


counts <- rep(0, nofGNT)
snames <- rep("", nofGNT)
for (i in 1:nofGNT) {
  R <- config$configR[i]
  nok <- 0
  for (r in 1:R) {
    if (mccmultree.is.simmultree(config, i, r)) {
      nok <- nok + 1
      }
    }
  counts[i] <- nok
  gens <- ""
  if (abs(config$configT[i] - 4e-8) < 1e-16) { gens <- "Gens = 1,000,000" }
  if (abs(config$configT[i] - 8e-8) < 1e-16) { gens <- "Gens =   500,000" }
  snames[i] <- paste(" G =", config$configG[i], "N =", config$configN[i], gens)
  cat(scenario.name, "G =", config$configG[i], "N =", config$configN[i], 
         "T =", config$configT[i], nok, "/", R, "\n")
  }

#fn <- display.gtree(config, 12, 1, 6)


display.barplot()

png("C:/AAA/Docs/PCTeX/Biology/Goteborg/TreesWithLegs/svg/5-5-barplot.png", width=1024, height=768)
display.barplot()
dev.off()
